# -*- coding: utf-8 -*-

import binascii
import os
import uuid

from odoo import api, fields, models

class IoTPairing(models.Model):
    _name = 'openerp.enterprise.iot.pairing'
    _description = 'IoT pairing tokens'

    pairing_code = fields.Char(default=lambda x: binascii.hexlify(os.urandom(3)).upper(), index=True)
    pairing_uuid = fields.Char(default=lambda x: str(uuid.uuid4()))
    create_date = fields.Datetime(index=True, readonly=True)
    db_uuid = fields.Char()
    database_url = fields.Char()
    enterprise_code = fields.Char()
    database_token = fields.Char()

    @api.autovacuum
    def _gc_tokens(self):
        expired_datetime = fields.Datetime.subtract(fields.Datetime.now(), minutes=5)
        pairing_tokens = self.search([('create_date', '<', expired_datetime)])
        pairing_tokens.unlink()
